#-*- coding:utf-8 -*-
# PyTalkTime.py
# Copyright (c) 2008-2016 masa 
# version = 1.03(0)

"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""

import e32
import audio
import time
import re
import sysinfo
import os
import appuifw

# Please change this part according to your environment
sound_path = "E:\\Sounds\\ttsound\\"
ini_file = "E:\\Data\\masa\\PyTalkTime.ini"
dat_file = "E:\\Data\\masa\\PyTalkTime.dat"
# use this file when can not read ini file
DingDong_file = "00.mp3"
#Volume Initial value
VOL1 = 5 #for file except  '00.mp3' # value range:1<-->10
VOL2 = 5 #for file '00.mp3'         # value range:1<-->10
#for debug, LOG_FILE / LOG_FLG
LOG_FILE = 'E:\\Data\\masa\\PyTalkTime.log' #*1
LOG_FLG = 0 #*1
#

if VOL1 > 10:volume_lebel=10
if VOL1 < 1 :volume_lebel=1
if VOL2 > 10:volume_lebel=10
if VOL2 < 1 :volume_lebel=1

#if os.path.exists(LOG_FILE):
#    LOG_FLG = 1
#else:
#    LOG_FLG = 0

try:
    import appswitch
    appswitch.switch_to_bg(u'PyTalkTime')
except ImportError:
    pass

script_lock = e32.Ao_lock()


def conf_read():
    global VOL1
    global VOL2
    global LOG_FLG

    # read ini file
    try :
        f = open(ini_file,'r')
        fData = f.read()
        f.close()
    except :
        return

    fData = unicode(fData)
    TalkTime_list = fData.split(u"\n")

    # search line of volume value
    for lnData in TalkTime_list:
        lnDatawk = re.sub(u"[ \t]+",u" ",lnData)
        Sdata = lnDatawk.split(u" ")

        if len(Sdata) < 2: continue # no Sdata[1] error
        if Sdata[0].upper() == u"VOLUME1":
            if int(Sdata[1]) <= 10: VOL1 = int(Sdata[1])
            else:                   VOL1 = 10
        if Sdata[0].upper() == u"VOLUME2":
            if int(Sdata[1]) <= 10: VOL2 = int(Sdata[1])
            else:                   VOL2 = 10
        if Sdata[0].upper() == u"LOG_FLG": LOG_FLG = int(Sdata[1])

def do_dummy():
    return


def main_proc():
    global VOL1
    global VOL2
    global LOG_FILE
    global LOG_FLG

    LOG = '' #*1
    wkts = time.time()
    wkt  = wkts + 4  #calibrate time ex 9:59:58 -> 10:00:02
                     #add 4 (need larger than 2 (sec))
    stimes = time.strftime('%H:%M:%S', time.localtime(wkts))
    stime  = time.strftime('%H:%M', time.localtime(wkt))

#    appuifw.app.body = appuifw.Text()
    appuifw.app.exit_key_handler = do_dummy
    conf_read()

    LOG = LOG + 'device time= ' + stimes + '\n' + 'search time= ' + stime + '\n'

    # read dat file
    try :
        f = open(dat_file,'r')
        fData = f.read()
        f.close()
        LOG = LOG + '-dat file read OK \n' #*3
    except :
        fData = stime + " " + DingDong_file + " " + DingDong_file
        LOG = LOG + '-dat file read NG \n' #*3

    fData = unicode(fData)
    TalkTime_list = fData.split(u"\n")

    # search line of current time
    logwk = '-search|' #*3
    for lnData in TalkTime_list:
        lnDatawk = re.sub(u"[ \t]+",u" ",lnData)
        Sdata = lnDatawk.split(u" ")
        logwk = logwk + ' ' + Sdata[0].encode("utf-8")  #*3
        if unicode(stime) == Sdata[0]:
            LOG = LOG + '-search line OK \n' #*3
            break
    else:
        Sdata = [unicode(stime),unicode(DingDong_file),unicode(DingDong_file)]
        LOG = LOG + logwk + '\n-search line NG \n' #*3


    def cb(prev, curr, err):
        if curr == 1: script_lock.signal()

    # play sound file (the first data of Sdata is hh:mm)
    work_path = os.path.join(unicode(sound_path), unicode(DingDong_file))
    S = audio.Sound.open(work_path)
    Max_vol = S.max_volume() #E7-00:10000, before E7-00:10
    volume1 = int(Max_vol * (VOL1/10.0)) #don't change 10.0 -> 10
    volume2 = int(Max_vol * (VOL2/10.0)) #don't change 10.0 -> 10
    S.close()

    LOG = LOG + '-'  #*2
    for i in Sdata[1:]:
        LOG = LOG + ' ' + i.encode("utf-8") #*1
        Si = os.path.join(unicode(sound_path), i)
        S = audio.Sound.open(Si)
        # my 00.mp3's volume is very low
        if i == u"00.mp3": S.set_volume(volume2)
        else:              S.set_volume(volume1)

        S.play(1, 0, cb)
        script_lock.wait()
        S.close()
    e32.ao_sleep(0.3)


    if LOG_FLG == 1: #*1
        F = open(LOG_FILE,'a') #*1
        F.write(LOG + '\n----------\n')  #*2
        F.close() #*1

Profile = sysinfo.active_profile()
if Profile not in ["silent", "meeting", "offline"]:
    main_proc()

#appuifw.app.set_exit()
#sys.exit()

